﻿Imports System.Text
Public Class Form3
    Private chamadaRetornar As Boolean = False

    Private Sub Form3_FormClosing(sender As Object, e As FormClosingEventArgs) _
     Handles MyBase.FormClosing
        If chamadaRetornar Then
            chamadaRetornar = False
            Exit Sub
        End If
        If e.CloseReason = CloseReason.UserClosing Then
            Application.Exit()
        End If

    End Sub
    Sub CarregaVariaveis(ByVal leVariaveisDoArquivo As String)
        Dim mensagemErro As String = ""
        Dim podeUsarVersaoSalva As Boolean = False
        Dim leListaVariaveisDoArquivo As New List(Of ClassVariable)

        If leVariaveisDoArquivo.Length > 0 Then
            If ClassGlobals.MakeTextIntoVarlist(leVariaveisDoArquivo, leListaVariaveisDoArquivo, mensagemErro) Then
                If ClassGlobals.VariaveisNomesCoincidem(leListaVariaveisDoArquivo, ClassGlobals.pVarList) Then
                    podeUsarVersaoSalva = True
                End If
            End If
        End If
        If podeUsarVersaoSalva Then
            Me.txtVariaveis.Text = leVariaveisDoArquivo
            'Else
            '    Me.TextBoxVariables.Text = ClassGlobals.populateVariablesBox(True)
        End If


    End Sub
    Private Sub btnCalcular_Click(sender As Object, e As EventArgs) Handles btnCalcular.Click
        Dim strEquacao As String
        Dim listaVariaveisLocais As New List(Of ClassVariable)
        strEquacao = Me.txtEquacao.Text.Trim  ' .ToUpper
        If strEquacao.Length = 0 Then
            MessageBox.Show("Você não informou uma equação")
            Exit Sub
        End If

        Dim strVariaveis As String
        strVariaveis = Me.txtVariaveis.Text.Trim ' .ToUpper
        If strVariaveis.Contains("?") Then
            MessageBox.Show("Error: Você não substituiu todos os ? na equação.")
            Exit Sub
        End If
        Dim mensagemErro As String = ""

        Try
            Dim clsEq As New ClassEquation()
            clsEq.pOriginalEquation = strEquacao
            ClassGlobals.pVarList = ClassGlobals.GetVarList(clsEq.pProcessedEquation)
            If strVariaveis.Length = 0 Then
                ' user 
                ' didVariableSearch = True
                If ClassGlobals.pVarList.Count > 0 Then
                    Me.txtVariaveis.Text = ClassGlobals.populateVariablesBox(True)
                    MessageBox.Show("Informe os valores das variáveis e clique no botão Calcular.")
                    Exit Sub
                End If

            Else
                If Not ClassGlobals.MakeTextIntoVarlist(strVariaveis, listaVariaveisLocais, mensagemErro) Then
                    If ClassGlobals.VariaveisNomesCoincidem(listaVariaveisLocais, ClassGlobals.pVarList) Then

                    End If
                    Me.txtDiagnostico.Text = mensagemErro
                    Exit Sub
                End If
            End If
            ClassGlobals.pVarList = listaVariaveisLocais
            clsEq.AssignValuesToVariables()
            Me.txtResultado.Text = clsEq.CalcularEquacao().ToString
            Me.txtDiagnostico.Text = clsEq.printEquation
        Catch ex As Exception
            Me.txtDiagnostico.Text = ex.Message
        Finally
            'salva a equação e as variáveis no disco
            My.Computer.FileSystem.WriteAllText("equacao.txt", strEquacao, False)
            My.Computer.FileSystem.WriteAllText("variaveis.txt", strVariaveis, False)
        End Try

    End Sub

    Private Sub btnSair_Click(sender As Object, e As EventArgs) Handles btnSair.Click
        Application.Exit()
    End Sub

    Private Sub Form3_Load(sender As Object, e As EventArgs) Handles Me.Load
        Me.CenterToScreen()
        Me.txtEquacao.Text = ClassGlobals.pEquation
        Me.txtVariaveis.Text = ClassGlobals.pVariableSTRING

    End Sub

    Private Sub btnAjuda_Click(sender As Object, e As EventArgs) Handles btnAjuda.Click
        Dim sb As New StringBuilder("Informe uma equação :  5 * 3 + x - y * 99 - sqrt(8) ")
        sb.AppendLine("")
        sb.AppendLine("Se a equação possuir variáveis, como no exemplo acima, informe os seus valores na caixa de texto das 'variáveis', exemplo : x=5,y=8")
        sb.AppendLine("Agora clique em Calcular. O resultado será mostrado na caixa de texto RESULTADO.")
        sb.AppendLine("A estrutura da equação vai aparecer na caixa 'Diagnóstico'.")
        sb.AppendLine("A equação será desmembrada em seções, caso você tenha digitado algo errado e desejar corrigir, você pode retornar e ajustar os valores.")
        sb.AppendLine("Se houver uma mensagem de erro (devido a um erro de sintaxe ele será mostrado na caixa de diagnóstico).")
        sb.AppendLine("Atente para o fato de que o programa transforma para caixa alta todas letras da equação antes de processá-la.")
        MessageBox.Show(sb.ToString)
    End Sub

    Private Sub btnRetornar_Click(sender As Object, e As EventArgs) Handles btnRetornar.Click
        chamadaRetornar = True
        Me.Close()
        FormVariables.Show()
    End Sub
End Class
