﻿Imports System.Text
Public Class Form1
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.CenterToScreen()

        If My.Computer.FileSystem.FileExists("equacao.txt") Then
            Me.txtEquacao.Text = My.Computer.FileSystem.ReadAllText("equacao.txt")
        End If
    End Sub

    Private Sub btnProsseguir_Click(sender As Object, e As EventArgs) Handles btnProsseguir.Click
        Dim strEquacao As String

        strEquacao = Me.txtEquacao.Text.Trim
        If strEquacao.Length = 0 Then
            MessageBox.Show("Error: A equação esta em branco.")
            Exit Sub
        End If
        Try
            ClassGlobals.pclsEq = New ClassEquation()
            ClassGlobals.pclsEq.pOriginalEquation = strEquacao
            ClassGlobals.pVarList = ClassGlobals.GetVarList(ClassGlobals.pclsEq.pProcessedEquation)

            ClassGlobals.pEquation = strEquacao
        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Exit Sub
        End Try
        My.Computer.FileSystem.WriteAllText("equacao.txt", strEquacao, False)

        ClassGlobals.pFirstform = Me
        Me.Hide()
        If ClassGlobals.pVarList.Count = 0 Then
            Me.Hide()
            Form3.Show()
        Else
            Me.Hide()
            FormVariables.Show()
        End If

    End Sub

    Private Sub btnAjuda_Click(sender As Object, e As EventArgs) Handles btnAjuda.Click
        Dim sb As New StringBuilder("")

        sb.Append("Informe uma equação : ")
        sb.AppendLine("Por exemplo 'x = x ^ 3 - r * x'. Para indicar multiplicação, use r * x, e não rx.")
        sb.AppendLine("Algumas funções são suportadas. Exemplo : 'sqrt(x) * exp(x) - log10(q) * 3'")
        sb.AppendLine("Alguns operadores também são suportados. Ex: '^' (eleva a potência) ")

        MessageBox.Show(sb.ToString)
    End Sub
End Class